#include <stdio.h>
#include <ctype.h>
#include <string.h>

main(int argc,char **argv)
{
	FILE *in, *out;
	int p;
	char buff[512];
	char comm[60];
	char from[50],to[50],subject[50],folder[50];

	if (argc<2)
	{
		fprintf(stderr,"Usage: %s <files to import>\n",argv[0]);
		exit(-1);
	}
	p=1;

	while (p<argc)
	{
		if ((in=fopen(argv[p],"r"))==NULL)
		{
			perror(argv[p]);
			p++;
			continue;
		}
		while (!feof(in))
		{
			skipblank(in,buff);
			if (!strcmp(buff,"MWYS"))
			{
				int okay=0;
				/* found one for us */
				from[0]=to[0]=subject[0]=folder[0]=0;
				fgets(folder,50,in);
				strip(folder);
				do{
					okay=0;
					fgets(buff,512,in);
					strip(buff);
					if (!strncmp(buff,"From:",5))
					{
						strcpy(from,&buff[6]);
						okay=1;
					}else
					if (!strncmp(buff,"Message:",8))
					{
						/* ignore the message number */
						okay=1;
					}else
					if (!strncmp(buff,"Date:",5))
					{
						/* ignore the date */
						okay=1;
					}else
					if (!strncmp(buff,"To:",3))
					{
						strcpy(to,&buff[4]);
						okay=1;
					}else
					if (!strncmp(buff,"Subject:",8))
					{
						strcpy(subject,&buff[9]);
						okay=1;
					}else
					if (!strncmp(buff,"Flags:",6))
					{
						/* ignore the status flags */
						okay=1;
					}
				}while (okay);
				
				if (from[0]==0 || to[0]==0 || subject[0]==0)
				{
					fprintf(stderr,"Incomplete message header.\n");
					skiptodot(in);
					continue;
				}
			
				sprintf(comm,"mw -f %s %s",folder,from);
				if ((out=popen(comm,"w"))==NULL)
				{
					perror("running mw");
					exit(0);
				}
				fprintf(out,"%s\n",to);
				fprintf(out,"%s\n",subject);
				do{
					fprintf(out,"%s\n",buff);
					fgets(buff,512,in);
					strip(buff);
				}while (!feof(in) && !(buff[0]=='.' && buff[1]==0));
				fprintf(out,".\n");
				pclose(out);
			}else
				skiptodot(in);
		}
		fclose(in);
		p++;
	}
}

skipblank(FILE *in, char *buff)
{
	do{
		fgets(buff,512,in);
		strip(buff);
	}while (!feof(in) && buff[0]=='\n');
}

strip(char *buff)
{
	int i,l,p;
	char tmp[512];
	l=strlen(buff);
	p=0;
	for (i=0;i<l;i++)
	{
		if (isprint(buff[i]) && buff[i]!='\r')
			tmp[p++]=buff[i];
	}
	tmp[p]=0;
	strcpy(buff,tmp);
}

skiptodot(FILE *in)
{
	char tmp[512];
	do{
		fgets(tmp,512,in);
		strip(tmp);
	}while (!feof(in) && !(tmp[0]=='.' && tmp[1]==0));
}

