/*********************************************************
 *     The Milliways III System is copyright 1992        *
 *      J.S.Mitchell. (arthur@sugalaxy.swan.ac.uk)       *
 *       see licence for furthur information.            *
 *********************************************************/
#include <stdio.h>
#include <fcntl.h>
#define HOMEPATH	"/usr/local/lib/mw"

#define NAMESIZE 	16    /* username */
#define PASSWDSIZE 	20   /* password (after encryption) */
#define SUBJECTSIZE 	40   /* Subject field on messages */
#define FOLNAMESIZE 	10   /* length of folder names */
#define TOPICSIZE 	30   /* length of the topic of the folder */
#define REALNAMESIZE	30   /* real name */
#define CONTACTSIZE 	60   /* contact address */
#define SCREENWIDTH	80   /* for the auto word-wrap */


struct person 
{
	char name[NAMESIZE+1];
	char passwd[PASSWDSIZE+1];
	long lastlogin; 
	long folders[2]; /* which folders are subscribed to */
	unsigned char status;
	unsigned short special;
	int  lastread[64]; /* last message read in each folder */
	char realname[REALNAMESIZE+1];
	char contact[CONTACTSIZE+1];
	long timeused;
	long idletime;
	char groups;
	char doing[80];
	char spare[18]; /*adjust size as necessary */
};

struct listing 
{
	char name[NAMESIZE+1];
	unsigned long time;
	struct listing *next;
}Node;

char *time_on(unsigned long u)
{
	int s,m,h,d;
	static char buff[80];
	
	d=u/(60*60*24);
	h=u%(60*60*24);
	h=h/(60*60);
	m=u%(60*60);
	m=m/60;
	s=u%60;

	buff[0]=0;
	if (d>0)
		sprintf(buff,"%d day%s, ",d,d>1?"s":"");
	if (h>0)
		sprintf(buff,"%s%d hour%s, ",buff,h,h>1?"s":"");
	if (m>0)
		sprintf(buff,"%s%d minute%s, ",buff,m,m>1?"s":"");
	sprintf(buff,"%s%d second%s.\n",buff,s,s==1?"":"s");
	return(buff);
}


int IsBigger(a,b)
struct listing *a,*b;
{
	if (a->time < b->time) return(1); else return(0);
}

struct listing *Insert(a,b)
struct listing *a,*b;
{
	struct listing *c=a;
	struct listing *p;
	while(c&&IsBigger(b,c))
	{
		p=c;
		c=c->next;
	}
	if(c==a)
	{
		b->next=c;
		return(b);
	}
	p->next=b;
	b->next=c;
	return(a);
}
struct listing *Sort(head)
struct listing *head;
{
	struct listing *new=NULL;
	struct listing *this=head;
	struct listing *next;
	while(this)
	{
		next=this->next;
		new=Insert(new,this);
		this=next;
	}
	return(new);
}


main(argc,argv)
int argc;
char **argv;
{
	struct listing *head;
	char fullpath[128];
	struct person user;
	struct listing *new;
	struct listing *ptr;
	int file;
	head=NULL;

	sprintf(fullpath,"%s/users.bb",HOMEPATH);
	
	if ((file=open(fullpath,O_RDONLY))<0)
	{
		perror("users.bb");
		exit(-1);
	}
	new=(struct listing *)malloc(sizeof(*new));
	while(read(file,&user,sizeof(user))>0)
	{
		if (!(user.status&(1<<7)))
		{
			strcpy(new->name,user.name);
			new->time=user.timeused;
			new->next=head;
			head=new;
			new=(struct listing *)malloc(sizeof(*new));
		}
	}
	head=Sort(head);
	printf("Top User login times\n");
	ptr=head;
	while (ptr!=NULL)
	{
		printf("Name: %*s %ld %s",NAMESIZE,ptr->name,ptr->time,time_on(ptr->time));
		ptr=ptr->next;
	}
}
