/*********************************************************
 *     The Milliways III System is copyright 1992        *
 *      J.S.Mitchell. (arthur@sugalaxy.swan.ac.uk)       *
 *       see licence for furthur information.            *
 *********************************************************/
#include <stdio.h>
#include <fcntl.h>
#include "../bb.h"

#define NEW_END	".t"
int internet=0;

main(argc,argv)
int argc;
char **argv;
{
	char fullpath[PATHSIZE],fp2[PATHSIZE];
	struct Header index;
	char *textbuff;
	int textin,textout;
	int indexin,indexout;
	int ffile;
	int limit;
	int counter=0;
	int i;
	int first=0xffff;
	struct folder info;
	
	if (argc!=2)
	{
		fprintf(stderr,"Usage: %s <foldername>\n",argv[0]);
		exit(-1);
	}

/* locate the folder that you want to tidy. */

	sprintf(fullpath,"%s/%s",HOMEPATH,FOLDERFILE);
	if ((ffile=open(fullpath,O_RDWR))<0)
	{
		perror(FOLDERFILE);
		exit(-1);
	}
	
	do {
		i=read(ffile,&info,sizeof(info));
	}while (i==sizeof(info) && !stringcmp(info.name,argv[1],-1));

	if (i<sizeof(info))
	{
		printf("Folder %s not found.\n",argv[1]);
		exit(0);
	}
/* display relavant info */
	printf("Folder: %s,  Topic: %s\n",info.name,info.topic);
	printf("Messages %d to %d\n",info.first,info.last);
	printf("\nDelete messsges number to delete up to: ");
	do{
		gets(fp2);
		limit=atoi(fp2);
		if (fp2[0]==0) limit=0;
		if (limit==info.last)
			printf("You must leave at least one message, or go and delete the folder.\n");
	}while ((limit<info.first || limit>=info.last) && fp2[0]!=0);
	if (fp2[0]==0)
	{
		printf("Aborted.\n");
		exit(0);
	}
	

	
	
/* open relavant folder */
	sprintf(fullpath,"%s/%s%s",HOMEPATH,info.name,INDEX_END);
	if (access(fullpath,00))
	{
		fprintf(stderr,"Folder %s not found.\n",info.name);
		exit(-1);
	}
	if ((indexin=open(fullpath,O_RDONLY))<0)
	{
		perror(argv[0]);
		exit(-1);
	}
	Lock_File(indexin);
	
	sprintf(fullpath,"%s/%s%s",HOMEPATH,info.name,TEXT_END);
	if (access(fullpath,00))
	{
		fprintf(stderr,"Folder %s text file not found.\n",info.name);
		exit(-1);
	}
	if ((textin=open(fullpath,O_RDONLY))<0)
	{
		perror(argv[0]);
		exit(-1);
	}
	Lock_File(textin);
	
	sprintf(fullpath,"%s/%s%s%s",HOMEPATH,info.name,INDEX_END,NEW_END);
	if ((indexout=open(fullpath,O_WRONLY|O_CREAT,0600))<0)
	{perror(fullpath);exit(-1);}
	Lock_File(indexout);
	
	sprintf(fullpath,"%s/%s%s%s",HOMEPATH,info.name,TEXT_END,NEW_END);
	if ((textout=open(fullpath,O_WRONLY|O_CREAT,0600))<0)
	{perror(fullpath);exit(-1);}
	Lock_File(textout);
	
	printf("Copying all messages after number %d.\n",limit);
	while(read(indexin,&index,sizeof(index))>0)
	{
		if (index.Ref>limit)
		{
			first=index.Ref<first?index.Ref:first;
		textbuff=(char *)malloc(index.size+1);
		lseek(textin,index.datafield,0);
		read(textin,textbuff,index.size);
		index.datafield=lseek(textout,0,1);
		write(textout,textbuff,index.size);
		write(indexout,&index,sizeof(index));
		free(textbuff);
		counter++;
		}
	}
	printf("Copy complete, %d messages copied.\n",counter);
	printf("First message is now #%d\n",first);
	printf("Updating Real Folder...\n");


	close(indexout);
	sprintf(fullpath,"%s/%s%s",HOMEPATH,info.name,INDEX_END);
	sprintf(fp2,"%s/%s%s%s",HOMEPATH,info.name,INDEX_END,NEW_END);
	if (rename(fp2,fullpath)) perror("rename");
	Unlock_File(indexin);
	close(indexin);

	close(textout);
	sprintf(fullpath,"%s/%s%s",HOMEPATH,info.name,TEXT_END);
	sprintf(fp2,"%s/%s%s%s",HOMEPATH,info.name,TEXT_END,NEW_END);
	if (rename(fp2,fullpath)) perror("rename");
	Unlock_File(textin);
	close(textin);

	info.first=first;
	if ((lseek(ffile,-sizeof(info),SEEK_CUR))<0)
		perror("seek");
	write(ffile,&info,sizeof(info));
	close(ffile);

}
